"""
Copyright (c) 2008 Erik Tollerud (etolleru@uci.edu) 

This package contains a variety of utilities and algorithms for processing
and visualizing astronomical data.

**Modules**

* constants: physical constants and conversions, Cosmology objects for choosing 
  related sets of constants
* coords: Astronomical coordinate systems, distance measurements,
  and related objects
* obstools: Tools and corrections for observations (mostly optical)
* models: Fitting functions/models and related calculations
* objcat: Object Catalog objects and functions
* phot: Photometry objects and related functions
* spec: Spectrum objects and related functions
* ccd: Functions and tools for processing CCD images.

"""
